
package eu.dnetlib.dhp.rdfconverter.bioschema;

import java.io.InputStream;
import java.util.ArrayList;

import org.apache.commons.io.IOUtils;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import eu.dnetlib.dhp.rdfconverter.utils.RDFConverter;

public class ConverterTest {

	static Logger logger = LoggerFactory.getLogger(ConverterTest.class);

	@Test
	public void nqToDataciteTest() throws Exception {
		InputStream is = ConverterTest.class.getResourceAsStream("/eu/dnetlib/dhp/rdfconverter/bioschema/disprot.nq");
		String nq = IOUtils.toString(is);
		logger.debug("NQ: " + nq);
		RDFConverter converter = new RDFConverter();
		ArrayList<String> results = converter.nQuadsFile2DataciteJson(nq, "Protein");
		if (results != null && !results.isEmpty()) {
			logger.info("JSON DATACITE: " + results.get(0));
		}
	}

	@Test
	public void pedCitationTest() throws Exception {
		InputStream is = ConverterTest.class.getResourceAsStream("/eu/dnetlib/dhp/rdfconverter/bioschema/ped.nq");
		String nq = IOUtils.toString(is);
		logger.debug("NQ: " + nq);
		RDFConverter converter = new RDFConverter();
		ArrayList<String> results = converter.nQuadsFile2DataciteJson(nq, "Protein");
		if (results != null && !results.isEmpty()) {
			logger.info("JSON DATACITE: " + results.get(0));
		}
	}
}
